﻿#region License Information
/* HeuristicLab
 * Copyright (C) 2002-2013 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 *
 * This file is part of HeuristicLab.
 *
 * HeuristicLab is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * HeuristicLab is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
 */
#endregion

using System;
using System.Collections;
using System.Collections.Generic;
using HeuristicLab.Core;
using HeuristicLab.DataPreprocessing;
using HeuristicLab.Problems.DataAnalysis;

namespace HeuristicLab.DataPreprocessing {
  [Item("PreprocessingData", "Represents data used for preprocessing.")]
  public class PreprocessingData : NamedItem, IPreprocessingData {

    private Dictionary<string, IList> variableValues;

    public PreprocessingData(IDataAnalysisProblemData problemData)
      : base() {
      Name = "-";
      foreach (var s in problemData.Dataset.VariableNames) {
        if (problemData.Dataset.IsType<double>(s)) {

        } else if (problemData.Dataset.IsType<string>(s)) {

        } else if (problemData.Dataset.IsType<DateTime>(s)) {

        } else {
          throw new ArgumentException("The datatype of column " + s + "is of TODO");
        }
      }
      throw new NotImplementedException();
    }

    #region NamedItem abstract Member Implementations

    public override Common.IDeepCloneable Clone(Common.Cloner cloner) {
      throw new NotImplementedException();
    }

    #endregion

    #region IPreprocessingData Members

    public T GetCell<T>(int columnIndex, int rowIndex) {
      throw new NotImplementedException();
    }

    public void SetCell<T>(int columnIndex, int rowIndex, T value) {
      throw new NotImplementedException();
    }

    public T GetCell<T>(string variableName, int row) {
      throw new NotImplementedException();
    }

    public void SetCell<T>(string variableName, int row, T value) {
      throw new NotImplementedException();
    }

    public IEnumerable<T> GetValues<T>(int columnIndex) {
      throw new NotImplementedException();
    }

    public IEnumerable<T> GetValues<T>(string variableName) {
      throw new NotImplementedException();
    }

    public void SetValues<T>(int columnIndex, IEnumerable<T> values) {
      throw new NotImplementedException();
    }

    public void SetValues<T>(string variableName, IEnumerable<T> values) {
      throw new NotImplementedException();
    }

    public void InsertRow(int rowIndex) {
      throw new NotImplementedException();
    }

    public void DeleteRow(int rowIndex) {
      throw new NotImplementedException();
    }

    public void InsertColumn(string variableName, int columnIndex) {
      throw new NotImplementedException();
    }

    public void DeleteColumn(int columnIndex) {
      throw new NotImplementedException();
    }

    public void DeleteColumn(string variableName) {
      throw new NotImplementedException();
    }

    IEnumerable<string> IPreprocessingData.VariableNames {
      get { throw new NotImplementedException(); }
    }

    public bool IsType<T>(int columnIndex) {
      throw new NotImplementedException();
    }

    public bool IsType<T>(string variableName) {
      throw new NotImplementedException();
    }

    public int Columns {
      get { throw new NotImplementedException(); }
    }

    public int Rows {
      get { throw new NotImplementedException(); }
    }

    public void ExportTo(IDataAnalysisProblemData problemData) {
      throw new NotImplementedException();
    }

    #endregion
  }
}
